V3 = {}
V3.mt = {}
function V3.new(xx, yy, zz)
	local set = {x = xx, y = yy, z = zz}
	setmetatable(set, V3.mt)
	return set
end
function V3.print (s)
	print(V3.tostring(s))
end
function V3.mt.__add(a,b)
	local res = V3.new{}
	if getmetatable(a)~=V3.mt then
		return error("Error: Cannot Add "..type(a).." And V3", 2)
		--for k in pairs(a) do res[k] = b[k]+a end
	elseif getmetatable(b)~=V3.mt then
		return error("Error: Cannot Add V3 And "..type(b), 2)
		--for k in pairs(a) do res[k] = a[k]+b end
	else
		for k in pairs(a) do res[k] = a[k]+b[k] end
	end
	return res
end
function V3.mt.__mul(a,b)
	local res = V3.new{}
	if getmetatable(a)~=V3.mt then
		for k in pairs(b) do res[k] = b[k]*a end
	elseif getmetatable(b)~=V3.mt then
		for k in pairs(a) do res[k] = a[k]*b end
	else
		for k in pairs(a) do res[k] = a[k]*b[k] end
	end
	return res
end
function V3.mt.__sub(a,b)
	local res = V3.new{}
	if getmetatable(a)~=V3.mt then
		--return error("Error: Cannot Subject "..type(a).." And V3", 2)
		for k in pairs(b) do res[k] = b[k]+a end
	elseif getmetatable(b)~=V3.mt then
		--return error("Error: Cannot Subtract V3 And "..type(b), 2)
		for k in pairs(a) do res[k] = a[k]+b end
	else
		for k in pairs(a) do res[k] = a[k]-b[k] end
	end
	return res
end
function V3.mt.__div(a,b)
	local res = V3.new{}
	if getmetatable(a)~=V3.mt then
		for k in pairs(a) do res[k] = b[k]/a end
	elseif getmetatable(b)~=V3.mt then
		for k in pairs(a) do res[k] = a[k]/b end
	else
		for k in pairs(a) do res[k] = a[k]/b[k] end
	end
	return res
end
function V3.mt.__pow(a,b)
	local res = V3.new{}
	if getmetatable(a)~=V3.mt then
		for k in pairs(a) do res[k] = b[k]^a end
	elseif getmetatable(b)~=V3.mt then
		for k in pairs(a) do res[k] = a[k]^b end
	else
		for k in pairs(a) do res[k] = a[k]^b[k] end
	end
	return res
end
print("V3 Object Loaded!")
function V3.dist(a, b)
	dx = a.x-b.x
	dy = a.y-b.y
	dz = a.z-b.z
	d = math.sqrt(dx*dx+dy*dy+dz*dz)
	return d
end